{ Autor:             Sascha NEMECEK
  Mat.Nr.:           9825815
  Studienkennzahl:   E175
  Erstellungsdatum:  10.03.1999
  letzte nderung:   16.03.1999 }

program Mengenlehre;
uses crt, dos;


{ Typen definitionen }
TYPE

{ Definition eines Knotens der einfach verketteten Liste. }
KnotenPtr = ^Knoten;
Knoten = OBJECT
     next: KnotenPtr;
     data: INTEGER;
END;

{ Definition der einfach verketteten Liste. }
ListePtr = ^Liste;
Liste = OBJECT
     start, now: KnotenPtr;
     CONSTRUCTOR Init;
     PROCEDURE addElement (d : integer);
     PROCEDURE clearList;
     PROCEDURE gotoEnd;
     PROCEDURE gotoNext;
     PROCEDURE gotoStart;
     PROCEDURE removeElement;
     PROCEDURE sortList;
     PROCEDURE swapElements (e1, e2 : KnotenPtr);
     FUNCTION eol : boolean;
     FUNCTION find (d: INTEGER) : KnotenPtr;
     FUNCTION getData : INTEGER;
     FUNCTION IsEmpty : boolean;
     FUNCTION NumberOfElements : Integer;
     DESTRUCTOR done;
END;

{ Definition der 10 Mengen }
Mengen = array [0..9] of ListePtr;

{ Definition eines Strings fr Dateinamen }
string13 = array [0..13] of char;

{ Definition eines Strings fr Dateieinlesen }
string6 = array [0..6] of char;


{ Vereinbarungsteil fr globale Variablen }
var
   jn: char;
   px,py: byte;
   f: file;
   schirm: integer absolute$B800:$0000;



{ -------------------------------------------------------------------
   Begin der Klasse Liste
  -------------------------------------------------------------------}


{ Constructor Init.
  Setzt alle Anfangswerte. }
constructor Liste.Init;
begin
     start := NIL;
     now := NIL;
end;



{ Procedure addElement ().
  Fgt ein neues Element in der Liste ein.
  @param d Der einzufgende Datenwert. }
procedure Liste.addElement (d : integer);
VAR hptr: KnotenPtr;
begin
     new (hptr);
     hptr^.data := d;

     if find (d) <> NIL then exit;

     { Wenn das erste Element }
     if start <> NIL then
        hptr^.next := start
     else
        hptr^.next := NIL;
     start := hptr;
end;



{ Prozedur clearList.
  Lscht die gesamte Liste. }
procedure Liste.clearList;
begin
     gotoStart;
     while IsEmpty = false do
           removeElement
end;



{ Prozedur gotoEnd.
  Setzt den now Pointer auf das Ende der Liste. }
procedure Liste.gotoEnd;
begin
     while now^.next <> NIL do
           now := now^.next
end;



{ Prozedur gotoNext.
  Setzt den now Pointer auf das nchste Element in der Liste. }
procedure Liste.gotoNext;
begin
     if now = NIL then
        exit;
     if now^.next = NIL then
        exit;
     now := now^.next;
end;



{ Prozedur gotoStart.
  Setzt den now Pointer auf den Anfang der Liste. }
procedure Liste.gotoStart;
begin
     now := start;
end;



{ Prozedur removeElement.
  Lscht das aktuelle Element aus der Liste. }
procedure Liste.removeElement;
var h : KnotenPtr;
begin
     if (start = NIL) or (now = NIL) then
        exit;

     if now <> start then

     { Das nicht-erste Element wird gelscht. }
     begin
          h := start;
          while h^.next <> now do h := h^.next;
          h^.next := now^.next;
          dispose (now);
          now := h;

     { Das erste Element der Liste wird gelscht. }
     end else begin
          start := now^.next;
          dispose (now);
          now := start;
     end
end;



{ Prozedur sortList.
  Sortiert die Liste mit Selection Sort. }
procedure Liste.sortList;
var i, j: integer;
    hstart, kleinstes: KnotenPtr;
begin
     hstart := start;
     for i := 0 to NumberOfElements - 1 do
     begin
          kleinstes := hstart;
          now := hstart^.next;
          while now <> NIL do
          begin
                if now^.data < kleinstes^.data then
                   kleinstes := now;
                now := now^.next;
          end;
          swapElements (kleinstes, hstart);
          hstart := kleinstes^.next;
     end
end;



{ Prozedur swapElements.
  Vertauscht zwei Elemente miteinander.
  @param e1 das erste Element.
  @param e2 das zweite Element. }
procedure Liste.swapElements (e1, e2 : KnotenPtr);
var v1: KnotenPtr;
begin
     v1 := start;

     { Suchen des ersten Vorgngers. }
     if e1 <> start then begin
        while v1^.next <> e1 do v1 := v1^.next;
        v1^.next := e2;
     end else
        start := e2;

     v1 := start;

     { Suchen des zweiten Vorgngers. }
     if e2 <> start then begin
        while v1^.next <> e2 do v1 := v1^.next;
        v1^.next := e1;
     end else
        start := e1;

     { Nachfolger vertauschen. }
     v1 := e1^.next;
     e1^.next := e2^.next;
     e2^.next := v1;
end;



{ Function eol.
  berprft ob der now Pointer auf das letzte Element zeigt.
  @return TRUE, falls das Ende der Liste erreicht wurde. }
function Liste.eol : boolean;
var e: boolean;
begin
     e := FALSE;
     if now = NIL then e := TRUE;
     if now^.next = NIL then
        e := TRUE;
     eol := e;
end;



{ Function find ().
  Sucht nach dem Vorkommen eines Datenelements.
  @param d Zu suchendes Element.
  @return Zeiger auf gefundenes Element.
  }
function Liste.find (d: integer) : KnotenPtr;
var fund: KnotenPtr;
begin
     fund := NIL;
     gotoStart;
     while now <> NIL do
     begin
           if now^.data = d then
           begin
               fund := now;
               now := NIL;
           end else
               now := now^.next;
     end;
     find := fund;
end;



{ Prozedur getData.
  Liefert den Inhalt des aktuellen Elements.
  Keine berprfung ob berhaupt ein Element existiert.
  @return Inhalt des Datenelements. }
function Liste.getData : integer;
begin
     getData := now^.data;
end;



{ Function IsEmpty.
  berprft ob die Liste leer ist.
  @return True = leer; False = nicht leer. }
function Liste.IsEmpty : boolean;
var empty: boolean;
begin
     if start = NIL then
        empty := TRUE
     else
        empty := FALSE;
     IsEmpty := empty;
end;



{ Function NumberOfElements.
  Zhlt die Elemente in der Liste.
  @return Anzahl der Elemente in der Liste. }
function Liste.NumberOfElements : Integer;
var i : integer;
begin
     i := 1;
     gotoStart;
     if now = NIL then
         i := 0
     else
        while now^.next <> NIL do
        begin
           i := i + 1;
           now := now^.next;
        end;
     NumberOfElements := i;
     gotoStart
end;



{ Destructor done.
  Lscht alle Listenelemente wenn Liste nicht leer. }
destructor Liste.done;
begin
     if IsEmpty = false then
        clearList;
end;



{ -------------------------------------------------------------------
   End der Klasse Liste
  -------------------------------------------------------------------}



{ Prozedur timeshow ().
  Gibt die aktuelle Uhrzeit am Bildschirm aus.
  @param x Gibt die Wartezeit an. }
procedure timeshow (x:integer);
var h,m,s,hund,px,py:word;
begin
     {Abfrage der X-/Y-Koordinaten des Cursors}
     px:=wherex;py:=wherey;

     textbackground(white);
     textcolor(red);
     GetTime(h,m,s,hund);
     gotoxy(72,1);
     write(h:2,':',m:2,':',s:2);
     if h<10 then begin gotoxy(72,1);write('0');end;
     if m<10 then begin gotoxy(75,1);write('0');end;
     if s<10 then begin gotoxy(78,1);write('0');end;
     textcolor(7);
     gotoxy(px,py);
     delay(x);
end;



{ Prozedur ricky ().
  Leit bei Tastendruck ein Zeichen ein.
  @param jn Das gegebenes Zeichen. }
procedure ricky (var jn:char);
begin
     if keypressed then jn:=readkey;
end;



{ Prozedur WAIT.
  Wartet solange, bis [ENTER] gedrckt wird. }
procedure WAIT;
var jn:char;
begin
     textcolor(4);
     textbackground(white);
     gotoxy(35,25);
     write('Press Enter');
     jn:='1';
     repeat
           timeshow(100);
           ricky(jn);
     until (jn=chr(13));
     gotoxy(35,25);
     write('           ');
     textbackground(lightblue);
     textcolor(white);
end;



{ Prozedur wochtag ().
  Gibt den aktuellen Wochentag aus.
  @param x Gibt Wochentag an.}
procedure wochtag (x:word);
var y:string[10];
begin
     case x of
          1:y:='Montag';
          2:y:='Dienstag';
          3:y:='Mittwoch';
          4:y:='Donnerstag';
          5:y:='Freitag';
          6:y:='Samstag';
          0:y:='Sonntag';
     end;
     write(Y);
end;



{ Prozedur Datum.
  Gibt das aktuelle Datum aus }
procedure datum;
var jahr,mon,tag,wochentag:word;
begin
     gotoxy(33,1);
     getdate(jahr,mon,tag,wochentag);
     wochtag(wochentag);write(', ',tag,'.',mon,'.',jahr)
end;



{ Prozedur screen.
  Legt das Bildschirmlayout fest. }
procedure screen;
var i,j:integer;
begin
     textcolor(15);
     textbackground(15);
     clrscr;
     gotoxy(1,1);
     textbackground(white);
     textcolor(red);
     write('   Mengenverwaltung V1.0                                                          ');
     datum;
     gotoxy(1,2);
     textbackground(1);
     textcolor(9);
     for i:=1 to 1840 do write(#177);
     gotoxy(1,25);
     textbackground(white);
     textcolor(red);
     write('   Mengenverwaltung V1.0                                               (C) MAG ');
     textcolor(white);
end;



{ Prozedur getint ().
  Liet einen Integerwert ein.
  @param eingabe der Wert der eingelesen wird.
  @return true, wenn weiter eingelesen werden soll.
          false, wenn einlesen beendet werden soll.}
function getint (var eingabe:integer) : boolean;
var ein: char;
    i,ch: byte;
    neg: boolean;
begin
   eingabe := 0;
   ch := 0;
   neg := false;
   repeat
      { Einlesen eines gltigen Zeichens }
      repeat{$I-}
         ein := readkey;{$I+}
      until (ioresult=0) and ((ein>='0')and(ein<='9')and(ch=0)and(neg=false)
            or (ein>='0') and (ein<='9') and (eingabe<>0) or
            (ein>='1')and(ein<='9')and(ch=0)and(neg=true)) and (ch<=6) and
            (abs (eingabe)<3276) or ((ein=#13) and (ch>0)) or
            (ein=#8) or ((ein='-') and (ch=0)) or (ein=#27);

      if (ein<>#13) and (ein<>#27) and (ein<>'-')then
         if (ein<>#8) then begin
            write (ein);
            inc(ch);
            eingabe:=eingabe*10+(ord(ein)-48);
         end else if(ch>0)then begin
            write (#8,' ',#8);
            dec(ch);
            eingabe:=trunc(eingabe/10);
            if ch = 0 then begin
              if neg = true then write (#8,' ',#8);
              neg := false;
            end;
         end;
      if (ein=#8) and (neg=true) and (ch=0) then
         write (#8,' ',#8);
      if ein = '-' then
      begin
         neg := true;
         write (ein);
      end;
   until (ein = chr(13)) or (ein = chr(27));

   {Geschriebene Zeichen wieder lschen}
   for i := 0 to ch-1 do write (#8,' ',#8);

   {Wenn Minus: Zahl negativ machen]}
   if neg = true then begin
      write (#8,' ',#8);
      eingabe := -eingabe;
   end;

   if ein = chr(13) then getint := true
   else getint := false
end;



{ Prozedure neuein ().
  Durch sie kann eine Menge neu eingegeben werden.
  @param d die Mengen. }
procedure neuein(var d: Mengen);
var i,j,m,data: integer;
    jn: char;
    fund: boolean;
begin
  fund:=false;
  screen;
  for i:=1 to 7 do for j:=1 to 77 do begin
   textbackground(0);
   textcolor(blue);
   gotoxy(2+j,8+i);
   write('');
  end;
  textcolor(lightgray);
  textbackground(lightblue);
  gotoxy(2,8); write('ͻ');
  gotoxy(2,9); write('  Welche Menge [0-9]?                                                      ');
  gotoxy(2,10);write('  Element eingeben:                                                        ');
  gotoxy(2,11);write('                                                                           ');
  gotoxy(2,12);write('  Nchstes Element [ENTER]                                                 ');
  gotoxy(2,13);write('  Ende mit [ESC] (aktuelle Eingabe geht verloren)                          ');
  gotoxy(2,14);write('ͼ');

  { Menge auswhlen }
  gotoxy (25,9);
  repeat
   ricky(jn);
   timeshow(100);
  until (jn>='0') and (jn<='9');

  textbackground(lightblue);
  gotoxy (25,9);
  write (jn);
  m := ord (jn) - ord ('0');

  jn := 'J';
  if d[m]^.IsEmpty = FALSE then
  { Abfrage ob Menge berschreiben }
  begin
       for i:=1 to 3 do for j:=1 to 50 do begin
          textbackground(0);
          textcolor(blue);
          gotoxy(17+j,19+i);
          write('');
       end;
       textbackground(lightblue);
       textcolor(lightgray);
       gotoxy(17,19);write('ͻ');
       gotoxy(17,20);write('  Menge existiert schon! berschreiben? [J/N]?  ');
       gotoxy(17,21);write('ͼ');
       jn:='R';
       repeat
          ricky(jn);
          jn:=upcase(jn);
          timeshow(100);
       until (jn='N') or (jn='J');
       textbackground(1);textcolor(9);
       for i:=0 to 3 do for j:=0 to 50 do begin
           gotoxy(17+j,19+i);
           write('');
       end;
       textcolor(lightgray);
       textbackground(lightblue);
  end;

  gotoxy (25,10);
  if jn = 'J' then
  begin
     d[m]^.clearList;
     while getint (data) = TRUE do d[m]^.addElement (data);
  end;

  {neue Menge sortieren}
  d[m]^.sortList;
end;



{ Prozedur vereinigeMengen ().
  Vereinigt zwei Mengen und speichert sie in eine Dritte.
  @param d Mengen. }
procedure vereinigeMengen (d: Mengen);
var i, j, s1, s2, dest: integer;
    jn: char;
begin
  screen;
  for i:=1 to 7 do for j:=1 to 77 do begin
   textbackground(0);
   textcolor(blue);
   gotoxy(2+j,8+i);
   write('');
  end;
  textcolor(lightgray);
  textbackground(lightblue);
  gotoxy(2,8); write('ͻ');
  gotoxy(2,9); write('  1. Quellmenge:                                                           ');
  gotoxy(2,10);write('  2. Quellmenge:                                                           ');
  gotoxy(2,11);write('  Zielmenge:                                                               ');
  gotoxy(2,12);write('                                                                           ');
  gotoxy(2,13);write('  Abbruch mit [ESC]                                                        ');
  gotoxy(2,14);write('ͼ');

  { Erste Quellmenge auswhlen }
  gotoxy (25,9);
  jn := 'a';
  repeat
   ricky(jn);
   timeshow(100);
  until (jn>='0') and (jn<='9');

  textbackground(lightblue);
  write (jn);
  s1 := ord (jn) - ord ('0');

  { Zweite Quellmenge auswhlen }
  jn := 'a';
  gotoxy (25,10);
  repeat
   ricky(jn);
   timeshow(100);
  until (jn>='0') and (jn<='9');

  textbackground(lightblue);
  write (jn);
  s2 := ord (jn) - ord ('0');

  { Zielmenge auswhlen }
  jn := 'a';
  gotoxy (25,11);
  repeat
   ricky(jn);
   timeshow(100);
  until (jn>='0') and (jn<='9');

  textbackground(lightblue);
  write (jn);
  dest := ord (jn) - ord ('0');

  { berprfung ob Menge leer }
  jn := 'J';
  if d[dest]^.IsEmpty = FALSE then
  { Abfrage ob Menge berschreiben }
  begin
       for i:=1 to 3 do for j:=1 to 50 do begin
          textbackground(0);
          textcolor(blue);
          gotoxy(17+j,19+i);
          write('');
       end;
       textbackground(lightblue);
       textcolor(lightgray);
       gotoxy(17,19);write('ͻ');
       gotoxy(17,20);write('  Menge existiert schon! berschreiben? [J/N]?  ');
       gotoxy(17,21);write('ͼ');
       jn:='R';
       repeat
          ricky(jn);
          jn:=upcase(jn);
          timeshow(100);
       until (jn='N') or (jn='J');
       textbackground(1);textcolor(9);
       for i:=0 to 3 do for j:=0 to 50 do begin
           gotoxy(17+j,19+i);
           write('');
       end;
       textcolor(lightgray);
       textbackground(lightblue);
  end;

  if jn = 'J' then
  begin
       d[dest]^.clearList;

       { Bildet die Vereinigung der zwei Quellmengen }
       if d[s1]^.isEmpty = FALSE then
       for i:=0 to d[s1]^.NumberOfElements do begin
           d[dest]^.addElement (d[s1]^.getData);
           d[s1]^.gotoNext;
       end;
       if d[s2]^.isEmpty = FALSE then
       for i:=0 to d[s2]^.NumberOfElements do begin
           if d[dest]^.find (d[s2]^.getData) = NIL then
              d[dest]^.addElement (d[s2]^.getData);
           d[s2]^.gotoNext;
       end;
       d[dest]^.sortList;
  end;
end;



{ Prozedur durchschnittMengen ().
  Bildet den Durchschnitt zweier Mengen und speichert sie in eine Dritte.
  @param d Mengen. }
procedure durchschnittMengen (d: Mengen);
var i, j, s1, s2, dest: integer;
    jn: char;
begin
  screen;
  for i:=1 to 7 do for j:=1 to 77 do begin
   textbackground(0);
   textcolor(blue);
   gotoxy(2+j,8+i);
   write('');
  end;
  textcolor(lightgray);
  textbackground(lightblue);
  gotoxy(2,8); write('ͻ');
  gotoxy(2,9); write('  1. Quellmenge:                                                           ');
  gotoxy(2,10);write('  2. Quellmenge:                                                           ');
  gotoxy(2,11);write('  Zielmenge:                                                               ');
  gotoxy(2,12);write('                                                                           ');
  gotoxy(2,13);write('  Abbruch mit [ESC]                                                        ');
  gotoxy(2,14);write('ͼ');

  { Erste Quellmenge auswhlen }
  gotoxy (25,9);
  jn := 'a';
  repeat
   ricky(jn);
   timeshow(100);
  until (jn>='0') and (jn<='9');

  textbackground(lightblue);
  write (jn);
  s1 := ord (jn) - ord ('0');

  { Zweite Quellmenge auswhlen }
  jn := 'a';
  gotoxy (25,10);
  repeat
   ricky(jn);
   timeshow(100);
  until (jn>='0') and (jn<='9');

  textbackground(lightblue);
  write (jn);
  s2 := ord (jn) - ord ('0');

  { Zielmenge auswhlen }
  jn := 'a';
  gotoxy (25,11);
  repeat
   ricky(jn);
   timeshow(100);
  until (jn>='0') and (jn<='9');

  textbackground(lightblue);
  write (jn);
  dest := ord (jn) - ord ('0');

  { berprfung ob Menge leer }
  jn := 'J';
  if d[dest]^.IsEmpty = FALSE then
  { Abfrage ob Menge berschreiben }
  begin
       for i:=1 to 3 do for j:=1 to 50 do begin
          textbackground(0);
          textcolor(blue);
          gotoxy(17+j,19+i);
          write('');
       end;
       textbackground(lightblue);
       textcolor(lightgray);
       gotoxy(17,19);write('ͻ');
       gotoxy(17,20);write('  Menge existiert schon! berschreiben? [J/N]?  ');
       gotoxy(17,21);write('ͼ');
       jn:='R';
       repeat
          ricky(jn);
          jn:=upcase(jn);
          timeshow(100);
       until (jn='N') or (jn='J');
       textbackground(1);textcolor(9);
       for i:=0 to 3 do for j:=0 to 50 do begin
           gotoxy(17+j,19+i);
           write('');
       end;
       textcolor(lightgray);
       textbackground(lightblue);
  end;

  if jn = 'J' then
  begin
       d[dest]^.clearList;

       { Bildet den Durchschnitt der Quellmengen }
       for i:=0 to d[s2]^.NumberOfElements do begin
           if d[s1]^.find (d[s2]^.getData) <> NIL then
              d[dest]^.addElement (d[s2]^.getData);
           d[s2]^.gotoNext;
       end;
       d[dest]^.sortList;
  end;
end;



{ Prozedur differenzMengen ().
  Bildet die Differenz zweier Mengen und speichert sie in eine Dritte.
  @param d Mengen. }
procedure differenzMengen (d: Mengen);
var i, j, s1, s2, dest: integer;
    jn: char;
begin
  screen;
  for i:=1 to 7 do for j:=1 to 77 do begin
   textbackground(0);
   textcolor(blue);
   gotoxy(2+j,8+i);
   write('');
  end;
  textcolor(lightgray);
  textbackground(lightblue);
  gotoxy(2,8); write('ͻ');
  gotoxy(2,9); write('  1. Quellmenge:                                                           ');
  gotoxy(2,10);write('  2. Quellmenge:                                                           ');
  gotoxy(2,11);write('  Zielmenge:                                                               ');
  gotoxy(2,12);write('                                                                           ');
  gotoxy(2,13);write('  Abbruch mit [ESC]                                                        ');
  gotoxy(2,14);write('ͼ');

  { Erste Quellmenge auswhlen }
  gotoxy (25,9);
  jn := 'a';
  repeat
   ricky(jn);
   timeshow(100);
  until (jn>='0') and (jn<='9');

  textbackground(lightblue);
  write (jn);
  s1 := ord (jn) - ord ('0');

  { Zweite Quellmenge auswhlen }
  jn := 'a';
  gotoxy (25,10);
  repeat
   ricky(jn);
   timeshow(100);
  until (jn>='0') and (jn<='9');

  textbackground(lightblue);
  write (jn);
  s2 := ord (jn) - ord ('0');

  { Zielmenge auswhlen }
  jn := 'a';
  gotoxy (25,11);
  repeat
   ricky(jn);
   timeshow(100);
  until (jn>='0') and (jn<='9');

  textbackground(lightblue);
  write (jn);
  dest := ord (jn) - ord ('0');

  { berprfung ob Menge leer }
  jn := 'J';
  if d[dest]^.IsEmpty = FALSE then begin

     { Abfrage ob Menge berschreiben }
     for i:=1 to 3 do for j:=1 to 50 do begin
        textbackground(0);textcolor(blue);
        gotoxy(17+j,19+i);
        write('');
     end;
     textbackground(lightblue);
     textcolor(lightgray);
     gotoxy(17,19);write('ͻ');
     gotoxy(17,20);write('  Menge existiert schon! berschreiben? [J/N]?  ');
     gotoxy(17,21);write('ͼ');
     jn:='R';
     repeat
        ricky(jn);
        jn:=upcase(jn);
        timeshow(100);
     until (jn='N') or (jn='J');
     textbackground(1);textcolor(9);
     for i:=0 to 3 do for j:=0 to 50 do begin
        gotoxy(17+j,19+i);
        write('');
     end;
     textcolor(lightgray);textbackground(lightblue);
  end;

  if jn = 'J' then
  begin
       d[dest]^.clearList;

       { Bildet die Differenz der Quellmengen }
       if d[s2]^.isEmpty = false then
       for i:=0 to d[s2]^.NumberOfElements do begin
           if d[s1]^.find (d[s2]^.getData) = NIL then
              d[dest]^.addElement (d[s2]^.getData);
           d[s2]^.gotoNext;
       end;

       if d[s1]^.isEmpty = false then
       for i:=0 to d[s1]^.NumberOfElements do begin
           if d[s2]^.find (d[s1]^.getData) = NIL then
              d[dest]^.addElement (d[s1]^.getData);
           d[s1]^.gotoNext;
       end;
       d[dest]^.sortList;
  end;
end;



{ Prozedur showMengen ().
  Gibt alle Mengen am Bildschirm aus.
  @param d Die Mengen }
procedure showMengen (d: Mengen);
var i,j,k,z,x: integer;
begin
   z := 0;
   screen;
   textcolor(lightgray);textbackground(9);
   gotoxy(3,4); write('ͻ');

   for j:=0 to 9 do begin
      z:=z+1;

      { Fenster schlieen }
      if (z>= 18) then begin
         gotoxy(3,z+4);write('ͼ');
         wait;
         screen;
         textcolor(lightgray);textbackground(9);
         z:=1;
         gotoxy(3,4); write('ͻ');
      end;

      gotoxy (3, 4+z);
      write (' Menge [',j,']: ');
      d[j]^.gotoStart;
      if d[j]^.IsEmpty = true then write('{leer}');
      for i := 1 to d[j]^.NumberOfElements do begin
         x:=wherex;
         if x > 66 then begin
            for k := 0 to 76-x do
                write (' ');
            write ('');
            z := z+1;

            { Fenster schlieen }
            if (z>= 18) then begin
             gotoxy(3,z+4);write('ͼ');
             wait;
             screen;
             textcolor(lightgray);textbackground(9);
             z:=1;
             gotoxy(3,4); write('ͻ');
            end;

            gotoxy (3, 4+z);
            write ('            ');
         end;

         write (d[j]^.getData,' ');
         d[j]^.gotoNext;
      end;

      { Zeile fllen }
      x:=wherex;
      for i := 0 to 76-x do
         write (' ');
      write ('');
   end;

   gotoxy(3,z+5);write('ͼ');
   wait;
end;



{ Prozedur menu.
  Gibt die Auswahlmglichkeiten am Bildschirm aus. }
procedure menu;
var i,j:byte;
begin
 textcolor(blue);textbackground(0);
 for i:=1 to 10 do for j:=1 to 38 do begin
  gotoxy(22+j,7+i);
  write('');
 end;
 textbackground(9);textcolor(lightgray);
 gotoxy(22,7); write('ͻ');
 gotoxy(22,8); write('  1..Neue Menge eingeben            ');
 gotoxy(22,9); write('  2..Zwei Mengen vereinigen         ');
 gotoxy(22,10);write('  3..Durchschnitt zweier Mengen     ');
 gotoxy(22,11);write('  4..Differenz zweier Mengen        ');
 gotoxy(22,12);write('  5..Ausgabe aller Mengen           ');
 gotoxy(22,13);write('  6..Mengen laden                   ');
 gotoxy(22,14);write('  7..Mengen sichern                 ');
 gotoxy(22,15);write('  0..Programm beenden               ');
 gotoxy(22,16);write('ͼ');
end;



{ Prozedur strcpy6 ().
  Kopiert einen String in einen anderen.
  @param dest Der Zielstring.
  @param source Der Quellstring. }
{procedure strcpy6 (var dest: string6; source: string6);
var i:integer;
begin
     for i:=0 to length (source) do begin
         dest[i] := source[i];
     end;
end;}



{ Prozedur strclear6 ().
  Fllt einen String mit "#0" en.
  @param dest Der Zielstring. }
{procedure strclear6 (var dest: string6);
var i:integer;
begin
     for i:=0 to length (dest) do
         dest[i] := #0;
end;}



{ Prozedur strclear13 ().
  Fllt einen String mit "#0" en.
  @param dest Der Zielstring. }
procedure strclear13 (var dest: string13);
var i:integer;
begin
     for i:=0 to length (dest) do
         dest[i] := #0;
end;



{ Function strlen6 ().
  Ermittelt die lnge eines Strings.
  @param s Der zu untersuchende String. }
{function strlen6 (s: string6) : integer;
var i: integer;
begin
     i := 0;
     while s[i] <> #0 do
           inc (i);

     strlen6 := i;
end;}



{ Function ReadDateiName ().
  Liet einen Dateinamen von der Tastatur ein.
  @param name Der String der zurckgegeben wird.
  @return TRUE, wenn die Eingabe erfolgreich (gltig) war. }
function ReadDateiName (var name: string13) : boolean;
var count, ext: integer;
    taste: char;
begin
   count := 0;
   ext := 0;
   taste := #0;

   textbackground(9);textcolor(lightgray);
	strclear13 (name);

	gotoxy(25,10);
	write ('             ');
	gotoxy(25,10);

	while (taste <> #13) and (taste <> #27) do begin
      repeat
         ricky(taste);
         timeshow(100);
      until taste <> #0;

		if ((taste='.') and (ext=0) and (count>0)) then begin
			name[count] := taste;
			inc (ext);
         taste := #0;
      end;

      if (((taste >= '0') and (taste <= '9')) or
          ((taste <= 'z') and (taste >= 'a')) or
          ((taste <= 'Z') and (taste >= 'A'))) and
          (((count<8) and (ext=0)) or
          ((count<=8) and (ext<4) and (ext>0))) then begin
			name[count+ext] := upcase(taste);
			if (ext>0) then
				inc (ext)
			else
				inc (count);
         taste := #0;
		end;

		if ((taste=#8) and (count>0)) then begin
			if(ext>0) then
				dec (ext)
			else
				dec (count);
			name[count+ext] := #0;
         taste := #0;
		end;
      textbackground(9);textcolor(lightgray);
	   gotoxy(25,10);
	   write ('             ');
		gotoxy(25,10);
		write (name);
		gotoxy(25+count+ext,10);
	end;

	while (name [count+ext-1]=#32) do
		name[count+ext-1] := #0;

   if ((count+ext) > 0) and (taste <> #27) then
      ReadDateiName := true
   else
      ReadDateiName := false;
end;




{ Prozedure saveMengen ().
  Speichert die Mengen in ein angegebenen File.
  @param d Die Mengen }
procedure saveMengen (d: Mengen);
var ausdat: text;
    i,j: integer;
    dateiname: string13;
    jn: char;
begin
   screen;
   for i:=1 to 7 do for j:=1 to 77 do begin
       textbackground(0);
       textcolor(blue);
       gotoxy(2+j,8+i);
       write('');
   end;
   textcolor(lightgray);
   textbackground(lightblue);
   gotoxy(2,8); write('ͻ');
   gotoxy(2,9); write('                                                                           ');
   gotoxy(2,10);write('  Dateiname:                                                               ');
   gotoxy(2,11);write('                                                                           ');
   gotoxy(2,12);write('                                                                           ');
   gotoxy(2,13);write('  Abbruch mit [ESC]                                                        ');
   gotoxy(2,14);write('ͼ');

   { Eingabe des Dateinamens }
   if readDateiName (dateiname) = false then begin

      { Bei Abbruch dieser Eingabe }
      for i:=1 to 3 do for j:=1 to 50 do begin
          textbackground(0);textcolor(blue);
          gotoxy(17+j,19+i);
          write('');
      end;
      textbackground(lightblue);textcolor(lightgray);
      gotoxy(17,19);write('ͻ');
      gotoxy(17,20);write('         Es wurde keine Datei geffnet!         ');
      gotoxy(17,21);write('ͼ');
      wait;
      exit;
   end;

   { Versucht die angegebene Datei zu ffnen + berprfung
     ob Datei schon existiert. }
   {$I-}
   assign (ausdat, dateiname);
   reset (ausdat);
   if ioresult = 0 then begin

      { Abfrage ob Datei berschreiben }
      for i:=1 to 3 do for j:=1 to 50 do begin
         textbackground(0);textcolor(blue);
         gotoxy(17+j,19+i);
         write('');
      end;
      textbackground(lightblue);textcolor(lightgray);
      gotoxy(17,19);write('ͻ');
      gotoxy(17,20);write(' Datei existiert bereits!  berschreiben [J/N]? ');
      gotoxy(17,21);write('ͼ');
      jn:='R';
      repeat
         ricky(jn);
         jn:=upcase(jn);
         timeshow(100);
      until (jn='N') or (jn='J');
      textbackground(1);textcolor(9);
      for i:=0 to 3 do for j:=0 to 50 do begin
         gotoxy(17+j,19+i);
         write('');
      end;
      textcolor(lightgray);textbackground(lightblue);
   end;

   if jn = 'N' then begin
      close (ausdat);
      exit;
   end;
   rewrite (ausdat);
   {$I-}

   { Mengen in Datei schreiben }
   for j:=0 to 9 do begin
      for i := 1 to d[j]^.NumberOfElements do begin
         write (ausdat, d[j]^.getData);
         if d[j]^.eol = FALSE then write (ausdat,' ');
         d[j]^.gotoNext;
      end;
      writeln (ausdat, '');
   end;
   textbackground(lightblue);textcolor(lightgray);
   gotoxy(17,19);write('ͻ');
   gotoxy(17,20);write('          Datei erfolgreich gesichert!          ');
   gotoxy(17,21);write('ͼ');
   close (ausdat);
   wait;
end;



{ Prozedure loadMengen ().
  Ld die Mengen aus einem angegebenen File.
  @param d Die Mengen }
procedure loadMengen (d: Mengen);
var eindat: text;
    i,j,wert,code: integer;
    jn: char;
    buf: string[7];
    dateiname: string13;
    empty: boolean;

begin
   { berprfung ob Mengen leer sind }
   jn := 'J';
   empty := true;
   for i:=0 to 9 do
      if d[i]^.IsEmpty = FALSE then
         empty:=false;

   if empty = false then begin
      { Abfrage ob Menge berschreiben }
      for i:=1 to 3 do for j:=1 to 50 do begin
         textbackground(0);textcolor(blue);
         gotoxy(17+j,19+i);
         write('');
      end;
      textbackground(lightblue);
      textcolor(lightgray);
      gotoxy(17,19);write('ͻ');
      gotoxy(17,20);write(' Alle Mengen werden gelscht! Fortfahren [J/N]? ');
      gotoxy(17,21);write('ͼ');
      jn:='R';
      repeat
         ricky(jn);
         jn:=upcase(jn);
         timeshow(100);
      until (jn='N') or (jn='J');
      textbackground(1);textcolor(9);
      for i:=0 to 3 do for j:=0 to 50 do begin
         gotoxy(17+j,19+i);
         write('');
      end;
      textcolor(lightgray);textbackground(lightblue);
   end;

   if jn = 'J' then
      for i:=0 to 9 do
         d[i]^.clearList
   else
      exit;

   screen;
   for i:=1 to 7 do for j:=1 to 77 do begin
       textbackground(0);
       textcolor(blue);
       gotoxy(2+j,8+i);
       write('');
   end;
   textcolor(lightgray);
   textbackground(lightblue);
   gotoxy(2,8); write('ͻ');
   gotoxy(2,9); write('                                                                           ');
   gotoxy(2,10);write('  Dateiname:                                                               ');
   gotoxy(2,11);write('                                                                           ');
   gotoxy(2,12);write('                                                                           ');
   gotoxy(2,13);write('  Abbruch mit [ESC]                                                        ');
   gotoxy(2,14);write('ͼ');

   { Eingabe des Dateinamens }
   if readDateiName (dateiname) = false then begin

      { Bei Abbruch dieser Eingabe }
      for i:=1 to 3 do for j:=1 to 50 do begin
          textbackground(0);textcolor(blue);
          gotoxy(17+j,19+i);
          write('');
      end;
      textbackground(lightblue);textcolor(lightgray);
      gotoxy(17,19);write('ͻ');
      gotoxy(17,20);write('         Es wurde keine Datei geffnet!         ');
      gotoxy(17,21);write('ͼ');
      wait;
      exit;
   end;

   { Versucht die angegebene Datei zu ffnen }
   {$I-}
   assign (eindat, dateiname);
   reset (eindat);
   if ioresult<>0 then begin
      for i:=1 to 3 do for j:=1 to 50 do begin
          textbackground(0);textcolor(blue);
          gotoxy(17+j,19+i);
          write('');
      end;
      textbackground(lightblue);textcolor(lightgray);
      gotoxy(17,19);write('ͻ');
      gotoxy(17,20);write('         Fehler beim ffnen der Datei !         ');
      gotoxy(17,21);write('ͼ');
      wait;
      exit;
   end; {$I+}

   jn := #0;
   buf[0] := #0;

   j := 0;
   i := 0;

   d[j]^.clearlist;
   while not eof(eindat) and (j<=9) do begin
      read (eindat, jn);

      { Springt zur nchsten Liste }
      if jn = #13 then begin
         if (i > 0) and (i <= 6) then begin
            val (buf, wert, code);
            if (code = 0) and (d[j]^.find (wert) = NIL) then
               d[j]^.addElement (wert)
            else if code <> 0 then begin
               for i:=0 to 9 do
                   d[i]^.clearList;
               for i:=1 to 3 do for j:=1 to 50 do begin
                   textbackground(0);textcolor(blue);
                   gotoxy(17+j,19+i);
                   write('');
               end;
               textbackground(lightblue);textcolor(lightgray);
               gotoxy(17,19);write('ͻ');
               gotoxy(17,20);write('             Fehler im Dateiformat!             ');
               gotoxy(17,21);write('ͼ');
               close (eindat);
               wait;
               exit;
            end;
            buf[0] := #0;
         end;
         d[j]^.sortList;
         inc (j);
         if j<=9 then
            d[j]^.clearlist;
         i := 0;
      end;

      { Fgt der Liste ein Element hinzu }
      if jn = ' ' then
         if (i > 0) and (i <= 6) then begin
            val (buf, wert, code);
            if (code = 0) and (d[j]^.find (wert) = NIL) then
               d[j]^.addElement (wert)
            else if code <> 0 then begin
               for i:=0 to 9 do
                   d[i]^.clearList;
               for i:=1 to 3 do for j:=1 to 50 do begin
                   textbackground(0);textcolor(blue);
                   gotoxy(17+j,19+i);
                   write('');
               end;
               textbackground(lightblue);textcolor(lightgray);
               gotoxy(17,19);write('ͻ');
               gotoxy(17,20);write('             Fehler im Dateiformat!             ');
               gotoxy(17,21);write('ͼ');
               close (eindat);
               wait;
               exit;
            end;
            buf[0] := #0;
            i := 0;
         end;

      { Wertet eingelesenes Zeichen aus }
      if (jn <= '9') and (jn >= '0') or (jn = '-') then
         if i<6 then begin
            buf := buf + jn;
            inc (i);
         end else begin
             for i:=0 to 9 do
                 d[i]^.clearList;
             for i:=1 to 3 do for j:=1 to 50 do begin
                 textbackground(0);textcolor(blue);
                 gotoxy(17+j,19+i);
                 write('');
             end;
             textbackground(lightblue);textcolor(lightgray);
             gotoxy(17,19);write('ͻ');
             gotoxy(17,20);write('             Fehler im Dateiformat!             ');
             gotoxy(17,21);write('ͼ');
             close (eindat);
             wait;
             exit;
         end;

      { berprft ob Zahl noch im Integerbereich liegt }
      if ((buf[0]>='3') and (buf[1]>='2') and (buf[2]>='7') and (buf[3]>='6') and (buf[4]>'7')) or
         ((buf[0]='-') and (buf[1]>='3') and (buf[2]>='2') and (buf[3]>='7') and (buf[4]>='6') and (buf[5]>'8')) then begin
         for i:=0 to 9 do
             d[i]^.clearList;
         for i:=1 to 3 do for j:=1 to 50 do begin
             textbackground(0);textcolor(blue);
             gotoxy(17+j,19+i);
             write('');
         end;
         textbackground(lightblue);textcolor(lightgray);
         gotoxy(17,19);write('ͻ');
         gotoxy(17,20);write('       Ungltiges Zahlenformat in Datei !       ');
         gotoxy(17,21);write('ͼ');
         close (eindat);
         wait;
         exit;
      end;
   end;
   for i:=1 to 3 do for j:=1 to 50 do begin
       textbackground(0);textcolor(blue);
       gotoxy(17+j,19+i);
       write('');
   end;
   textbackground(lightblue);textcolor(lightgray);
   gotoxy(17,19);write('ͻ');
   gotoxy(17,20);write('          Datei erfolgreich geffnet !          ');
   gotoxy(17,21);write('ͼ');
   close (eindat);
   wait;
end;



{ Prozedur choice.
  Wartet im Men auf eine Eingabe. }
procedure choice;
var jn: char;
    d: Mengen;
    i,j: integer;
begin
     { Listen Initialisieren }
     for i:= 0 to 9 do
         new (d[i], Init);

     repeat
           screen;
           menu;

           {Abfrage der Tastatur&Ausgabe der Zeit}
           repeat
                 timeshow(100);
                 textcolor(7);
                 jn:='8';
                 ricky (jn);
           until(jn<='7')and(jn>='0');

           {Begin der Mehrfachabfrage}
           case jn of
                '1':neuein (d);
                '2':vereinigeMengen (d);
                '3':durchschnittMengen (d);
                '4':differenzMengen (d);
                '5':showMengen (d);
                '6':loadMengen (d);
                '7':saveMengen (d);
           end;
     until jn='0';

     textcolor(lightgray);textbackground(0);
     clrscr;
     for j:=0 to 9 do
     begin
      d[j]^.gotoStart;
      for i := 1 to d[j]^.NumberOfElements do
      begin
          write (d[j]^.getData,' ');
          d[j]^.gotoNext;
      end;
      writeln ('');
     end;

     { Speicher wieder freigeben }
     for i:= 0 to 9 do
         dispose (d[i], Done);
end;



{ Hauptprogramm.
  Sichert den aktuellen Bildschirminhalt und die Cursorposition.
  Startet das Men.
  Stellt den Ursprungszustand wieder her. }
begin
     {Abfrage der X-/Y-Koordinaten des Cursors}
     px:=wherex;py:=wherey;

     {Speichern des vorhandnen DOS-Bildschirms}
     assign(f,'SCHIRM');
     rewrite(f);
     blockwrite(f,schirm,32);
     close(f);
     {Ende der Speicherung des DOS-Bildschirms}

     { Men aufrufen }
     choice;

     {Wiederaufbau des DOS-Bildschirms}
     textcolor(white);textbackground(0);
     clrscr;
     reset(f);
     blockread(f,schirm,32);
     erase(f);
     {Ende des DOS-Bildschirm wiederaufbaus}

     {Rcksetzen des Cursors}
     gotoxy(px,py);
end.
